part of isyumi;

abstract class UI{

  final List<int> _id;
  final _EditListener _el;
  
  UI(this._id,this._el);
  
}

class _EditListener{
  
  final IsyumiTransfer _it;
  
  _EditListener(this._it);
  
  void appendDiv(List<int> id){
    
    _it.appendDiv
      ..id.value = id
      ..send();
  }
  
  void appendText(List<int> id){
      
    _it.appendText
      ..id.value = id
      ..send();
    
  }
  
  void appendAnchor(List<int> id){
    
    _it.appendAnchor
      ..id.value = id
      ..send();
    
  }
  
  void setText(List<int> id,String text){
    
    _it.setText
      ..id.value = id
      ..text.value = text
      ..send();
    
  }
  
  void setStringValue(List<int> id, dynamic value){
    _it.setStringValue
      ..id.value = id
      ..value.value = value
      ..send();
  }
  
  void appendTextInput(List<int> id){
    _it.appendTextInput
      ..id.value = id
      ..send();
  }
  
  void appendPasswordInput(List<int> id){
    _it.appendPasswordInput
      ..id.value = id
      ..send();
  }
  
  void setHref(List<int>id , String href){
    
    _it.setHref
      ..id.value = id
      ..href.value = href
      ..send();
    
  }
  
}

class Document extends UI implements Appendable{
  
  final Append append; 
  static const List<int> _body_id = const[];
  
  Document._(_EditListener _el):super(_body_id,_el),append = new Append(_body_id,_el);
  
  void _current_where_id(List<int> id){
    
  }
  
}

abstract class Appendable{
  
  Append get append;
  
}

class Append{
  
  final _EditListener _el;
  final List<int> _appendable_id;
  final List<UI> _uis = [];
  
  Append(this._appendable_id,this._el);  
  
  void text(void f(Text text)){
    
    Text t = _append((i) => new Text(i,_el));
    _el.appendText(t._id);
    f(t);
  }
  
  void div(void f(Div div)){
    Div div = _append((i) => new Div(i,_el));
    _el.appendDiv(div._id);
    f(div);
  }
  
  void anchor(void f(Anchor anchor)){
    Anchor anchor = _append((i) => new Anchor(i,_el));
    _el.appendAnchor(anchor._id);
    f(anchor);
  }
  
  void text_input(void f(TextInput text_input)){
    TextInput text_input = _append((i) => new TextInput(i,_el));
    _el.appendTextInput(text_input._id);
    f(text_input);
  }
  
  void password_input(void f(PasswordInput password_input)){
    PasswordInput password_input = _append((i) => new PasswordInput(i,_el));
    _el.appendPasswordInput(password_input._id);
    f(password_input);
  }
  
  UI _append(UI f(List<int> i)){
    UI ui = f(_getNextID());
    _uis.add(ui);
    return ui;
  }
  
  List<int> _getNextID(){
    int length = _uis.length ;
    List id = [];
    for(int i in _appendable_id){
      id.add(i);
    }
    id.add(length);
    return id;
  }
}

class Anchor extends UI{
  
  Anchor(List<int>id,_EditListener _el):super(id,_el);
  
  set text(String text){
    _el.setText(_id, text);
  }
  
  set href (String href){
    _el.setHref(_id,href);
  }
  
}

class Text extends UI{
  Text(List<int> id,_EditListener _el):super(id,_el);
  set text(String text){
    _el.setText(_id, text);
  }
}

class Div extends UI {
  final Append append;
  Div(List<int> id,_EditListener _el):super(id,_el),append = new Append(id,_el);
}

abstract class Input<T> extends UI{
  
  set value(T v);
  
  Input(List<int> id,_EditListener _el):super(id,_el);
}

abstract class StringInput extends Input<String>{
  
  set value(String value){
    _el.setStringValue(_id,value);
      
  }
  
  StringInput(List<int> id,_EditListener _el):super(id,_el);
}

class TextInput extends StringInput{
  TextInput(List<int> id,_EditListener _el):super(id,_el);
}

class PasswordInput extends StringInput{
  PasswordInput(List<int> id,_EditListener _el):super(id,_el);
}

