library isyumi_client;

import 'isyumi_transfer.dart';
import "dart:html";
import "dart:async";
import "dart:typed_data";

WebSocket ws;

Map<List<int>,Node> elements = {[]:document.body}; 

IsyumiTransfer it;

void main(){
  
  WebSocket ws = new WebSocket("ws://localhost:8888/");
  
  window.history.replaceState("", "",window.location.href);
  
  window.onPopState.listen((e) => it.url..url.value = window.location.href ..send());
  
  StreamController<Uint8List> sc = new StreamController<Uint8List>();
  
  ws.onMessage.listen((e){
    var fr = new FileReader()..readAsArrayBuffer(e.data);
    fr.onLoadEnd.listen((e){
      sc.add(fr.result);
    });
  });
  
  it = getTransfer(sc.stream,(data) =>  ws.sendTypedData(data));
  
  ws.onOpen.listen((e)=> it.url..url.value = window.location.href..send());
  
  it
      ..reset.onData.listen(onReset)
      ..appendDiv.onData.listen(onAppendDiv)
      ..appendText.onData.listen(onAppendText)
      ..appendAnchor.onData.listen(onAppendAnchor)
      ..appendTextInput.onData.listen(onAppendTextInput)
      ..appendPasswordInput.onData.listen(onAppendPasswordInput)
      ..setText.onData.listen(onSetText)
      ..setHref.onData.listen(onSetHref)
      ..setStringValue.onData.listen(onSetStringValue)
      ;
  
}

void onReset(e){
  document.body.nodes.clear();
}

void _addNode(List<int> id, Node node){
  elements[id] = node;
  List head = id.getRange(0, id.length-1).toList();
  getNodeFromID(head).append(node);
}

void onAppendDiv(e){
  _addNode(it.appendDiv.id.value,new DivElement());
}

void onAppendAnchor(e){
  _addNode(it.appendAnchor.id.value,new AnchorElement());
}

void onAppendText(e){
  _addNode(it.appendText.id.value,new Text(""));
}

void onAppendTextInput(e){
  _addNode(it.appendTextInput.id.value,new TextInputElement());
}

void onAppendPasswordInput(e){
  _addNode(it.appendPasswordInput.id.value,new PasswordInputElement());
}

void onSetStringValue(e){
  (getNodeFromID(it.setStringValue.id.value) as InputElement).value = it.setStringValue.value.value;
}

void onSetText(e){
  getNodeFromID(it.setText.id.value).text = it.setText.text.value;
}

void onSetHref(e){
  
  String href = it.setHref.href.value;
  
  (getNodeFromID(it.setHref.id.value) as AnchorElement)
      ..href = "javascript:void(0)"
      ..onClick.listen((e)=>onAnchorClick(href)); 
}

void onAnchorClick(String href){
  
  window.history.pushState("", "",href);
  it.url
    ..url.value = window.location.href
    ..send();
  
}

Node getNodeFromID(List needle){
  for(List<int> key in elements.keys){
    if(listIsEquals(key , needle)){
      return elements[key];
    }
  }
  return null;
}

bool listIsEquals(List l1, List l2){
  if(l1.length != l2.length) return false;
    for(int x = 0 ; x < l1.length ; x ++){
      if(l1[x] != l2[x]){
        return false;
      }
    }
  return true;
}
